/* Sistemas Integrados TEKNISA

Nome: 520C_DFSSTPS_GERA_NOTAFISCAL_CORPO_ENTRADA.SQL

Descrio:
PROCEDIMENTOS PARA GERAO DE NOTAS FISCAIS

Criao:
05/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_NOTAFISCAL_CORPO_ENTRADA' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE GERA_NOTAFISCAL_CORPO_ENTRADA
GO

CREATE PROCEDURE GERA_NOTAFISCAL_CORPO_ENTRADA
   @P_CDFILIAL          VARCHAR(04),
   @P_CDFILIRECE        VARCHAR(04),
   @P_CDEMPRESA         VARCHAR(02),
   @P_CDTIPOOPER        VARCHAR(02),
   @P_CDSERIEENTR       VARCHAR(04),
   @P_CDCLIENTE         VARCHAR(21),
   @P_DTENTRSAID        DATETIME,
   @P_IDSISTEMA         VARCHAR(03),
   @P_VRNOTAFISC        DOUBLE PRECISION,
   @P_PRXLANCTONF       VARCHAR(10) OUTPUT,
   @P_PRXLANCESTQ       VARCHAR(10) OUTPUT,
   @P_ATUAESTOQUE       VARCHAR(01)        = 'S',
   @P_NRAPURACFAT       VARCHAR(10)        = NULL,
   @P_NRLANCTONF        VARCHAR(10)        = NULL,
   @P_IDTPIJURTRAN      VARCHAR(01)        = NULL,
   @P_NRINSJURTRAN      VARCHAR(20)        = NULL,
   @P_NRPLACAVEIC       VARCHAR(07)        = NULL,
   @P_SGUFVEIC          VARCHAR(02)        = NULL,
   @P_IDPGTOFRETE       VARCHAR(01)        = NULL,
   @P_DSQTDEVOLU        VARCHAR(06)        = NULL,
   @P_DSESPECVOLU       VARCHAR(10)        = NULL,
   @P_DSMARCAVOLU       VARCHAR(10)        = NULL,
   @P_DSNUMEVOLU        VARCHAR(15)        = NULL,
   @P_VRPBRUTOVOLU      DOUBLE PRECISION   = NULL,
   @P_VRPLIQUVOLU       DOUBLE PRECISION   = NULL,
   @P_NRLANCESTQ        VARCHAR(10)        = NULL,
   @P_NRLANCORIG        VARCHAR(16)        = NULL,
   @P_DTLANCAMENNF      DATETIME           = NULL,
   @P_NRNOTAFISC        VARCHAR(20)        = NULL,
   @P_DTEMISSAO         DATETIME           = NULL,
   @P_NRACESSONFE       VARCHAR(50)        = NULL,
   @P_CDMODDOCFISC      VARCHAR(02)        = NULL
AS
   DECLARE @V_IDORIGDESTNF VARCHAR(01);
   DECLARE @V_IDTPIJURNF   VARCHAR(01);
   DECLARE @V_NRINSJURNF   VARCHAR(20);
   DECLARE @V_CDFORNECED   VARCHAR(21);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDFILIEMIT   VARCHAR(21);
   DECLARE @V_CDINSCESTA   VARCHAR(16);
   DECLARE @V_CDINSCMUNI   VARCHAR(16);
   DECLARE @V_IDDOCFATUR   VARCHAR(01);
   DECLARE @V_IDDOCFISCENT VARCHAR(01);
   DECLARE @V_IDDOCESTOQUE VARCHAR(01);
   DECLARE @V_CDMODDOCFISC VARCHAR(02);
   DECLARE @V_NRLANCTONF   VARCHAR(20);
   DECLARE @V_NRLANCESTQ   VARCHAR(20);

   DECLARE @V_NOVO_CODIGO  VARCHAR(18);   
BEGIN
   SET @V_IDORIGDESTNF   = NULL;
   SET @V_IDTPIJURNF     = NULL;
   SET @V_NRINSJURNF     = NULL;
   SET @V_CDCLIENTE      = NULL;
   SET @V_CDFORNECED     = NULL;
   SET @V_CDFILIEMIT     = NULL;
   SET @V_CDINSCESTA     = NULL;
   SET @V_CDINSCMUNI     = NULL;
   SET @V_CDFILIEMIT     = NULL;

   SELECT @V_IDORIGDESTNF = MAX(IDORIGDESTOP)
   FROM TIPOOPERAC
   WHERE CDTIPOOPER   = @P_CDTIPOOPER AND
         IDENTRSAIDOP = 'E';

   SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
     FROM MODDOCFISCTPOP MT
    WHERE MT.IDENTRSAIDOP = 'E'
      AND MT.CDTIPOOPER   = @P_CDTIPOOPER
      AND MT.CDMODDOCFISC = @P_CDMODDOCFISC;

   IF (@V_CDMODDOCFISC IS NULL) BEGIN
      SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
        FROM MODDOCFISCTPOP MT
       WHERE MT.IDENTRSAIDOP = 'E'
         AND MT.CDTIPOOPER   = @P_CDTIPOOPER;
   END;

   IF @V_IDORIGDESTNF IS NULL BEGIN
      SET @V_IDORIGDESTNF = 'F';
   END;

   IF @V_IDORIGDESTNF = 'C' BEGIN
      SELECT @V_IDTPIJURNF = MAX(IDTPIJURCLIE), @V_NRINSJURNF   = MAX(NRINSJURCLIE),
             @V_CDCLIENTE  = MAX(CDCLIENTE)
      FROM CLIENTE
      WHERE CDCLIENTE = @P_CDCLIENTE;
   END
   ELSE IF @V_IDORIGDESTNF = 'F' BEGIN
      SELECT @V_IDTPIJURNF = MAX(IDTPIJURFORN), @V_NRINSJURNF   = MAX(NRINSJURFORN),
             @V_CDFORNECED = MAX(CDFORNECED)
      FROM FORNECEDOR
      WHERE CDFORNECED = @P_CDCLIENTE;
   END
   ELSE BEGIN
      SELECT @V_IDTPIJURNF = MAX(IDTPIJURFILI), @V_NRINSJURNF = MAX(NRINSJURFILI),
             @V_CDFILIEMIT = MAX(CDFILIAL)
      FROM FILIAL
      WHERE CDFILIAL = @P_CDCLIENTE;
   END;

   SELECT @V_CDINSCESTA = MAX(F.CDINSCESTA), @V_CDINSCMUNI = MAX(F.CDINSCMUNI)
     FROM FILIAL F, INSCRESTAD I
    WHERE (F.CDFILIAL   = @P_CDFILIRECE)
      AND (F.CDEMPRESA  = @P_CDEMPRESA)
      AND (I.CDINSCESTA = F.CDINSCESTA)
      AND (I.CDEMPRESA  = F.CDEMPRESA)
      AND (ISNULL(@P_DTENTRSAID, CONVERT(VARCHAR(12),GETDATE(), 101)) >= ISNULL(ISNULL(CONVERT(VARCHAR(12),I.DTINIVIGIEST, 101), @P_DTENTRSAID), CONVERT(VARCHAR(12),GETDATE(), 101)))
      AND (ISNULL(@P_DTENTRSAID, CONVERT(VARCHAR(12),GETDATE(), 101)) <= ISNULL(ISNULL(CONVERT(VARCHAR(12),I.DTFIMVIGIEST, 101), @P_DTENTRSAID), CONVERT(VARCHAR(12),GETDATE(), 101)));


   IF (@V_CDINSCESTA IS NULL) OR (@V_CDINSCMUNI IS NULL) BEGIN
      SELECT @V_CDINSCESTA = MAX(E.CDINSCESTA), @V_CDINSCMUNI = MAX(E.CDINSCMUNI)
        FROM EMPRCNTRFIL E, INSCRESTAD I
       WHERE (E.CDFILIAL   = @P_CDFILIRECE)
         AND (E.CDEMPRESA  = @P_CDEMPRESA)
         AND (E.CDINSCESTA = I.CDINSCESTA)
         AND (E.CDEMPRESA  = I.CDEMPRESA)
         AND (ISNULL(@P_DTENTRSAID, CONVERT(VARCHAR(12),GETDATE(), 101)) >= ISNULL(ISNULL(CONVERT(VARCHAR(12),I.DTINIVIGIEST, 101), @P_DTENTRSAID), CONVERT(VARCHAR(12),GETDATE(), 101)))
         AND (ISNULL(@P_DTENTRSAID, CONVERT(VARCHAR(12),GETDATE(), 101)) <= ISNULL(ISNULL(CONVERT(VARCHAR(12),I.DTFIMVIGIEST, 101), @P_DTENTRSAID), CONVERT(VARCHAR(12),GETDATE(), 101)));
   END;

   IF (@V_CDINSCESTA IS NULL) OR (@V_CDINSCMUNI IS NULL) BEGIN
      SELECT @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
        FROM FILIAL
       WHERE (CDFILIAL  = @P_CDFILIRECE)
         AND (CDEMPRESA = @P_CDEMPRESA);
   END;

   IF @P_IDSISTEMA IN ('DFE') BEGIN
      SET @V_IDDOCFISCENT = 'S';
   END
   ELSE BEGIN
      SET @V_IDDOCFISCENT = 'N';
   END;

   IF @P_IDSISTEMA IN ('EST') BEGIN
      SET @V_IDDOCESTOQUE = 'S';
   END   
   ELSE BEGIN
      SET @V_IDDOCESTOQUE = 'N';
   END;

   IF @P_NRLANCTONF IS NULL BEGIN
      SET @V_NOVO_CODIGO = 'LANCNF/FILIAL' + @P_CDFILIAL;
      EXEC NOVO_CODIGO @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;
      SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);
   END
   ELSE BEGIN
      SET @V_NRLANCTONF = @P_NRLANCTONF;
   END;


   IF @P_ATUAESTOQUE = 'S' BEGIN
      IF @P_NRLANCESTQ IS NULL BEGIN
         SET @V_NOVO_CODIGO = 'LANCTOEST' + @P_CDFILIAL;
         EXEC NOVO_CODIGO @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_NRLANCESTQ OUTPUT, @P_QTDE = 1;
         SET @V_NRLANCESTQ = SUBSTRING(@V_NRLANCESTQ, 11, 10);
      END
      ELSE BEGIN
         SET @V_NRLANCESTQ = @P_NRLANCESTQ;
      END;
   END
   ELSE BEGIN
      SET @V_NRLANCESTQ = '';
   END;

   INSERT INTO NOTAFISCAL
      (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
       CDFILIEMIT,   CDFILIRECE,   IDTPIJURNF,   NRINSJURNF,   CDFORNECED,
       CDCLIENTE,    IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  DTENTRSAID,
       VRPRODUTOS,   VRNOTAFISC,   NRPLACAVEIC,  SGUFVEIC,     IDPGTOFRETE,
       DSQTDEVOLU,   DSESPECVOLU,  DSMARCAVOLU,  DSNUMEVOLU,   VRPBRUTOVOLU,
       VRPLIQUVOLU,  IDENTRSAIDOP, CDTIPOOPER,   CDSERIEENTR,  IDTPIJURTRAN,
       NRINSJURTRAN, IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,   IDDOCFISCENT,
       IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    CDMODDOCFISC, IDORIGDESTNF,
       NRAPURACFAT,  CDINTEGRACAO, DTLANCAMENNF, NRNOTAFISC, DTEMISSAO, NRACESSONFE)
   VALUES
      (@P_CDFILIAL,     @V_NRLANCTONF,   @P_CDEMPRESA,    @V_CDINSCESTA,   @V_CDINSCMUNI,
       @V_CDFILIEMIT,   @P_CDFILIRECE,   @V_IDTPIJURNF,   @V_NRINSJURNF,   @V_CDFORNECED,
       @V_CDCLIENTE,    'N',            'S',            'S',               @P_DTENTRSAID,
       0,               @P_VRNOTAFISC,   @P_NRPLACAVEIC,  @P_SGUFVEIC,     @P_IDPGTOFRETE,
       @P_DSQTDEVOLU,   @P_DSESPECVOLU,  @P_DSMARCAVOLU,  @P_DSNUMEVOLU,   @P_VRPBRUTOVOLU,
       @P_VRPLIQUVOLU,  'E',             @P_CDTIPOOPER,   @P_CDSERIEENTR,  @P_IDTPIJURTRAN,
       @P_NRINSJURTRAN, 'S',            'P',              @V_IDDOCFATUR,   'N',
       @V_IDDOCFISCENT, @V_IDDOCESTOQUE, @P_IDSISTEMA,    @V_CDMODDOCFISC, @V_IDORIGDESTNF,
       @P_NRAPURACFAT,  @P_NRLANCORIG,   @P_DTLANCAMENNF, @P_NRNOTAFISC,   @P_DTEMISSAO, @P_NRACESSONFE);

   SET @P_PRXLANCTONF = @V_NRLANCTONF;
   SET @P_PRXLANCESTQ = @V_NRLANCESTQ;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_CORPO_ENTRADA','6.05.XXX';
GO


